package com.maroontress.sanctuary;

/**
   CΥȤޤʸ륯饹
*/
public final class CommentedString {

    /**
       ʸѡ̤Τ륤󥿥ե
    */
    public interface ParsedListener {
	/**
	   ƥȡ󥳥ȡˤΤޤ

	   @param s ƥ
	   @return ѡߤtrue, ³false
	*/
	boolean textNotify(String s);

	/**
	   ȤΤޤ

	   @param s 
	   @return ѡߤtrue, ³false
	*/
	boolean commentNotify(String s);
    }

    /**
       ʸִ륤󥿥ե
    */
    public interface Replacer {
	/**
	   ʸִޤ

	   @param s ִʸ
	   @return ִ줿ʸ
	*/
	String replace(String s);
    }

    /**
       󥹥󥹤ػߤޤ
    */
    private CommentedString() {
    }

    /**
       CΥȤޤʸѡޤ

       @param s ѡʸ
       @param listener ѡ̤Τ륤󥹥
       @throws UnterminatedCommentException CΥȤüƤ
       硢ޤ
    */
    public static void parse(final String s, final ParsedListener listener) {
	int j;
	String t = s;

	while (t.length() > 0 && (j = t.indexOf("/*")) != -1) {
	    String u = t.substring(0, j);
	    String v = t.substring(j + 2);
	    int k = v.indexOf("*/");

	    if (k == -1) {
		throw new UnterminatedCommentException(s);
	    }
	    if (listener.textNotify(u)
		|| listener.commentNotify("/*" + v.substring(0, k) + "*/")) {
		return;
	    }
	    t = v.substring(k + 2);
	}
	listener.textNotify(t);
    }

    /**
       CΥȰʳʸǽ˽иʸΰ֤ޤ

       @param s ʸ
       @param c ʸ
       @return cǽ˽иsΰ֡ޤ-1
       @throws UnterminatedCommentException CΥȤüƤ
       硢ޤ
    */
    public static int indexOf(final String s, final char c) {
	FirstCharFinder finder = new FirstCharFinder(c);
	parse(s, finder);
	return finder.getResult();
    }

    /**
       ʸ˴ޤޤCΥȤѹʸִޤ

       @param s ִʸ
       @param replacer ʸִ륤󥹥
       @return ִ줿ʸ
       @throws UnterminatedCommentException CΥȤüƤ
       硢ޤ
    */
    public static String replaceAll(final String s, final Replacer replacer) {
	final StringBuilder b = new StringBuilder();
	parse(s, new ParsedListener() {
	    public boolean textNotify(final String sub) {
		b.append(replacer.replace(sub));
		return false;
	    }
	    public boolean commentNotify(final String sub) {
		b.append(sub);
		return false;
	    }
	});
	return b.toString();
    }

    /**
       ʸ󤫤CΥȤʸޤ

       Ȥ1ĤζѴޤ

       @param s ʸ
       @return Ȥʸ
       @throws UnterminatedCommentException CΥȤüƤ
       硢ޤ
    */
    public static String deleteComments(final String s) {
	final StringBuilder b = new StringBuilder();
	parse(s, new ParsedListener() {
	    public boolean textNotify(final String sub) {
		b.append(sub);
		return false;
	    }
	    public boolean commentNotify(final String sub) {
		b.append(" ");
		return false;
	    }
	});
	return b.toString();
    }
}
